/*
 *      SmoothAlgorithms.mqh  
 *  : __\MQL5\Include
 *
 *          
 * JRSX.         
 *  JMA ,       .
 */

//+------------------------------------------------------------------+ 
//|                                                        JJurX.mq4 | 
//|                           Copyright  2010,     Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//----   
#property version   "1.00"
//----     
#property indicator_chart_window 
//----   
#property indicator_buffers 1 
//----     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----   1   
#property indicator_type1   DRAW_LINE
//----        Gold
#property indicator_color1 Gold
//----   -  
#property indicator_style1  STYLE_SOLID
//----     1
#property indicator_width1  2
//----    
#property indicator_label1  "JJurX"
//+-----------------------------------+
//|         |
//+-----------------------------------+
enum Applied_price_ //  
  {
   PRICE_CLOSE_ = 1,     //PRICE_CLOSE
   PRICE_OPEN_,          //PRICE_OPEN
   PRICE_HIGH_,          //PRICE_HIGH
   PRICE_LOW_,           //PRICE_LOW
   PRICE_MEDIAN_,        //PRICE_MEDIAN
   PRICE_TYPICAL_,       //PRICE_TYPICAL
   PRICE_WEIGHTED_,      //PRICE_WEIGHTED
   PRICE_SIMPLE,         //PRICE_SIMPLE
   PRICE_QUARTER_,       //PRICE_QUARTER
   PRICE_TRENDFOLLOW0_,  //PRICE_TRENDFOLLOW0
   PRICE_TRENDFOLLOW1_   //PRICE_TRENDFOLLOW1
  };
input int JurX_Length  = 5; // JurX  
input int JJMA_Length  = 4; // JJMA  
input int  JJMA_Phase=-100; //  ,
                            //   -100 ... +100,
                            //    ;
input  Applied_price_  IPC=PRICE_CLOSE_; // 
/*      ( 1-CLOSE, 2-OPEN, 3-HIGH, 4-LOW, 
  5-MEDIAN, 6-TYPICAL, 7-WEIGHTED, 8-SIMPLE, 9-QUARTER, 10-TRENDFOLLOW, 11-0.5 * TRENDFOLLOW.) */
input int Shift=0; //     
input int PriceShift=0; //     
//+-----------------------------------+
//----  
double Ind_Buffer[];
//----
double dPriceShift;
//+------------------------------------------------------------------+
//   iPriceSeries()                                   |
//   iPriceSeriesAlert()                              |
//   JJMA                                              |
//    CJurX                                            |
//+------------------------------------------------------------------+ 
#include <SmoothAlgorithms.mqh> 
//+------------------------------------------------------------------+
//| JJurX indicator initialization function                          | 
//+------------------------------------------------------------------+   
void OnInit()
  {
//----      
   SetIndexBuffer(0,Ind_Buffer,INDICATOR_DATA);
//----     
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,30);
//---      DataWindow
   PlotIndexSetString(0,PLOT_LABEL,"JJurX");
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----      
   string shortname;
   StringConcatenate
   (shortname,"JJurX( JurX_Length = ",JurX_Length,
    ", JJMA_Length = ",JJMA_Length,")");
//----           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//----     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----    CJJMA   JJMASeries_Cls.mqh
   CJJMA JMA;
//----       
   JMA.JJMALengthCheck("JJMA_Length", JJMA_Length);
   JMA.JJMALengthCheck("JurX_Length", JurX_Length);
//----       
   JMA.JJMAPhaseCheck("JJMA_Phase",JJMA_Phase);
//----    
   dPriceShift=_Point*PriceShift;
//----  
  }
//+------------------------------------------------------------------+
//| JJurX iteration function                                         | 
//+------------------------------------------------------------------+ 
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<30)return(0);

//----   
   int first,bar;

//----       
   double series,jurx,jjurx;

   if(prev_calculated>rates_total || prev_calculated<=0) //      
      first=0; //      
   else first=prev_calculated-1; //      

//----    JurX   JurXSeries_Cls.mqh
   static CJurX Jur;

//----    JJMA   JJMASeries_Cls.mqh
   static CJJMA JMA;

//----    
   for(bar=first; bar<rates_total; bar++)
     {
      //----   PriceSeries     Series
      series=PriceSeries(IPC,bar,open,low,high,close);

      //----     JurXSeries 
      //----  Length      (Din = 0).  
      jurx=Jur.JurXSeries(0,prev_calculated,rates_total,0,JurX_Length,series,bar,false);

      //----     JJMASeries
      //----  Phase  Length      (Din = 0).  
      jjurx=JMA.JJMASeries(0,prev_calculated,rates_total,0,JJMA_Phase,JJMA_Length,jurx,bar,false);

      //----             
      Ind_Buffer[bar]=jjurx+dPriceShift;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+